#Anti-Start-at-0-degrees (tm)
execute as @a unless score @s ssns.temperature matches ..0 unless score @s ssns.temperature matches 1.. run scoreboard players set @s ssns.temperature 200000


#Options
execute as @a[scores={ssns.optionChoic=1..}] at @s run function seasons:option_tick


#Test if in boat
tag @a remove inBoat
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:boat"}}}] run tag @s add inBoat


#Weather Markers
execute as @a unless score @s ssns.marker matches 1.. run scoreboard players set @s ssns.marker 0
scoreboard players set playersCount ssns.marker 0
execute as @a run scoreboard players add playersCount ssns.marker 1
scoreboard players set res ssns.marker 0
execute if score i ssns.marker < playersCount ssns.marker run scoreboard players set res ssns.marker 1
execute if score res ssns.marker matches 1 run scoreboard players add i ssns.marker 1
execute if score res ssns.marker matches 1 run scoreboard players operation @r[scores={ssns.marker=0}] ssns.marker = i ssns.marker
execute if score res ssns.marker matches 1 as @a at @s if score @s ssns.marker = i ssns.marker run summon area_effect_cloud ~ ~ ~ {Tags:["global.ignore"],Age:-2147483648,Duration:-1,WaitTime:-2147483648,CustomName:"{\"text\":\"weatherMarker\"}"}
execute if score res ssns.marker matches 1 as @e[type=area_effect_cloud,name=weatherMarker] unless score @s ssns.marker matches 1.. run scoreboard players operation @s ssns.marker = i ssns.marker
execute if score i ssns.marker > playersCount ssns.marker run kill @e[type=area_effect_cloud, name=weatherMarker]
execute if score i ssns.marker > playersCount ssns.marker run scoreboard players set @a ssns.marker 0
execute if score i ssns.marker > playersCount ssns.marker run scoreboard players set i ssns.marker 0


#Season timer
execute store result score seasonTimer ssns.value run time query day
execute store result score day ssns.value run time query daytime
scoreboard players operation seasonTimer ssns.value *= #24000 ssns.value
scoreboard players operation seasonTimer ssns.value += day ssns.value
scoreboard players operation seasonTimer ssns.value %= yearLimit ssns.value


#Seasons Change Messages
execute if score seasonTimer ssns.value matches 0 run tellraw @a[tag=seasons.sendMessages] ["",{"text":"Autumn Start, Happy New Year!","color":"gold"}]
execute if score seasonTimer ssns.value = winterLimit ssns.value run tellraw @a[tag=seasons.sendMessages] ["",{"text":"Winter Start","color":"aqua"}]
execute if score seasonTimer ssns.value = springLimit ssns.value run tellraw @a[tag=seasons.sendMessages] ["",{"text":"Spring Start, Happy Spring Festival!","color":"green"}]
execute if score seasonTimer ssns.value = summerLimit ssns.value run tellraw @a[tag=seasons.sendMessages] ["",{"text":"Summer Start","color":"yellow"}]


#Solstice
execute if score seasonTimer ssns.value = solsticeStart ssns.value if score solsticeDuration ssns.value matches 0 if score #solstice ssns.value matches 1 run function seasons:events/solstice_start
execute if score solsticeDuration ssns.value matches 1.. run function seasons:events/solstice


#Spring Festival
execute if score seasonTimer ssns.value >= springLimit ssns.value if score seasonTimer ssns.value < festivalEnd ssns.value if score #springFestival ssns.value matches 1 run function seasons:events/spring_festival


#Animal becoming in love in Spring
execute as @e[tag=!inLoveAlready,type=#passives] store result score @s ssns.value2 run data get entity @s Age
tag @e[tag=!inLoveAlready,type=#passives,scores={ssns.value2=..-1}] add inLoveAlready

function seasons:rng/nextrand
execute if score seasonTimer ssns.value >= springLimit ssns.value if score seasonTimer ssns.value < summerLimit ssns.value if score #randval mcprng matches 1..5 as @e[tag=!inLoveAlready,type=#passives,limit=1] run function seasons:make_in_love
execute if score seasonTimer ssns.value < springLimit ssns.value run tag @e[tag=inLoveAlready] remove inLoveAlready
execute if score seasonTimer ssns.value >= summerLimit ssns.value run tag @e[tag=inLoveAlready] remove inLoveAlready


#Blood Moon/End Incursion
execute if score day ssns.value matches 12000 run function seasons:events/start_night_events

execute if score #bloodMoon ssns.value matches 1.. run function seasons:events/blood_moon
execute if score day ssns.value matches 1 at @e[tag=toSend] run particle portal ~ ~1.5 ~ .25 .5 .25 .01 10
execute if score day ssns.value matches 1 at @e[tag=toSend] run playsound entity.enderman.teleport neutral @a
execute if score day ssns.value matches 1 as @e[tag=toSend] at @s run tp @s ~ -255 ~


#Sandstorm
execute as @a[scores={ssns.sandstorm=1..}] at @s if blocks ~ ~1 ~ ~ 255 ~ ~ 255 ~ masked run function seasons:events/sandstorm


#Death Management
execute as @a[scores={ssns.temperature=..-100000,ssns.health=..1},nbt=!{ActiveEffects:[{Id:20b}]}] at @s run function seasons:death/freeze
execute as @a[scores={ssns.temperature=500000..,ssns.health=..1},nbt=!{ActiveEffects:[{Id:20b}]}] at @s run function seasons:death/overheat
execute as @a[scores={ssns.deaths=1..}] at @s run function seasons:death


#Temperature
execute if score #temperature ssns.value matches 1 run function seasons:temperature/main


#Wetness
execute as @a[gamemode=survival] at @s if score #wetness ssns.value matches 1 run function seasons:wetness
execute as @a[gamemode=adventure] at @s if score #wetness ssns.value matches 1 run function seasons:wetness


#RandomTickSpeed
execute if score seasonTimer ssns.value < winterLimit ssns.value run gamerule randomTickSpeed 3
execute if score seasonTimer ssns.value >= winterLimit ssns.value if score seasonTimer ssns.value < springLimit ssns.value run gamerule randomTickSpeed 0
execute if score seasonTimer ssns.value >= springLimit ssns.value if score seasonTimer ssns.value < summerLimit ssns.value run gamerule randomTickSpeed 6
execute if score seasonTimer ssns.value >= summerLimit ssns.value run gamerule randomTickSpeed 2


#Weather control
execute as @a[tag=!onOcean,nbt={Dimension:"minecraft:overworld"}] at @s run function seasons:weather/main
execute as @a[tag=onOcean,nbt={Dimension:"minecraft:overworld"}] at @s run function seasons:weather/pseudo_weather

function seasons:rng/nextrand
execute if score isRaining ssns.value matches 2 if score day ssns.value matches 1 run weather clear
execute if score isRaining ssns.value matches 2 if score day ssns.value matches 1 run scoreboard players set isRaining ssns.value 0
execute if score seasonTimer ssns.value < winterLimit ssns.value run function seasons:weather/seasons/autumn
execute if score seasonTimer ssns.value >= winterLimit ssns.value if score seasonTimer ssns.value < springLimit ssns.value run function seasons:weather/seasons/winter
execute if score seasonTimer ssns.value >= springLimit ssns.value if score seasonTimer ssns.value < summerLimit ssns.value run function seasons:weather/seasons/spring
execute if score seasonTimer ssns.value >= summerLimit ssns.value run function seasons:weather/seasons/summer


##Effect on Mobs:
#Skeleton outside to Strays in Winter
execute as @e[type=skeleton,tag=!tested] at @s if score seasonTimer ssns.value >= winterLimit ssns.value if score seasonTimer ssns.value < springLimit ssns.value if blocks ~ ~1 ~ ~ 255 ~ ~ 255 ~ masked if score #skeleToStrays ssns.value matches 1 run function seasons:temperature/turn_stray
execute as @e[type=skeleton,tag=!tested] at @s if score seasonTimer ssns.value >= winterLimit ssns.value if score seasonTimer ssns.value < springLimit ssns.value run tag @s add tested

#Zombies outside to Husks in Summer
execute as @e[type=zombie,tag=!tested] at @s if blocks ~ ~1 ~ ~ 255 ~ ~ 255 ~ masked if score seasonTimer ssns.value >= summerLimit ssns.value if score #zombToHusks ssns.value matches 1 run function seasons:temperature/turn_husk
execute as @e[type=zombie,tag=!tested] at @s if score seasonTimer ssns.value >= summerLimit ssns.value run tag @s add tested


#Calendars
execute as @e[type=item_frame,nbt={Item:{id:"minecraft:paper",tag:{Enchantments:[{id:"seasons:calendar"}]}}}] at @s unless block ~ ~ ~ air run setblock ~ ~ ~ air destroy
execute as @e[type=item_frame,nbt={Item:{id:"minecraft:paper",tag:{Enchantments:[{id:"seasons:calendar"}]}}}] at @s if score day ssns.value matches 0 run function seasons:calendars
execute as @e[type=item_frame,nbt={Item:{id:"minecraft:paper",tag:{display:{Name:'{"text":"Calendar","italic":false}'},Enchantments:[{id:"seasons:calendar"}]}}}] at @s run function seasons:calendars
execute as @e[type=item,nbt={Item:{id:"minecraft:paper",tag:{Enchantments:[{id:"seasons:calendar"}]}}}] run data modify entity @s Item.tag.display.Name set value '{"text":"Calendar","italic":false}'


#Values Reset
scoreboard players set @a run 0
execute as @a store result score @s ssns.Y run data get entity @s Pos[1]