#Natural Drying
execute unless blocks ~ ~1 ~ ~ 255 ~ ~ 255 ~ masked run scoreboard players remove @s ssns.wetness 1
execute if score isRaining ssns.value matches ..0 run scoreboard players operation @s ssns.wetness -= @s ssns.dryRate

execute run scoreboard players operation @s ssns.value = @s ssns.tempdelta
execute run scoreboard players operation @s ssns.value /= #100 ssns.value
execute if score @s ssns.value matches 1.. run scoreboard players operation @s ssns.wetness -= @s ssns.value


#Underwater
execute as @s[tag=!inBoat] if block ~ ~ ~ water run scoreboard players add @s ssns.wetness 10
execute if block ~ ~1 ~ water run scoreboard players add @s ssns.wetness 20

#Rain
execute as @s[nbt=!{Inventory:[{Slot:103b,id:"minecraft:leather_helmet"}]}] unless score @s ssns.dryRate matches 2.. if data entity @s {Dimension:"minecraft:overworld"} if blocks ~ ~1 ~ ~ 255 ~ ~ 255 ~ masked run scoreboard players operation @s ssns.wetness += isRaining ssns.value

#Limit
execute if score @s ssns.wetness matches 10001.. run scoreboard players set @s ssns.wetness 10000
execute if score @s ssns.wetness matches ..-1 run scoreboard players set @s ssns.wetness 0


##Effects: 
#Dripping
execute if score @s ssns.wetness matches 2500..4999 run particle falling_water ~ ~.8 ~ .25 .5 .25 1 1
execute if score @s ssns.wetness matches 5000..7499 run particle falling_water ~ ~.8 ~ .25 .5 .25 1 2
execute if score @s ssns.wetness matches 7500..10000 run particle falling_water ~ ~.8 ~ .25 .5 .25 1 4

#Dropping wet items
function seasons:rng/nextrand
execute as @s[nbt={SelectedItem:{}}] if score @s ssns.wetness matches 9000.. if score #randval mcprng matches 1..100 run function seasons:drop_item