function seasons:rng/load
scoreboard players set #maxrand mcprng 10000
gamerule doWeatherCycle false

scoreboard objectives add ssns.inJungle dummy
scoreboard objectives add ssns.sandstorm dummy
scoreboard objectives add ssns.biomeTemp dummy
scoreboard objectives add ssns.dryRate dummy
scoreboard objectives add ssns.temperature dummy
scoreboard objectives add ssns.tempdelta dummy
scoreboard objectives add ssns.marker dummy
scoreboard objectives add ssns.wetness dummy
scoreboard objectives add ssns.value dummy
scoreboard objectives add ssns.value2 dummy
scoreboard objectives add ssns.temp2 dummy
scoreboard objectives add ssns.Y dummy
scoreboard objectives add ssns.health health
scoreboard objectives add ssns.deaths deathCount
scoreboard objectives add ssns.optionChoic trigger
scoreboard objectives add ssns.run minecraft.custom:minecraft.sprint_one_cm

#scoreboard players set world ssns.temperature 200000
scoreboard players set nether ssns.temperature 1000000
scoreboard players set end ssns.temperature -500000
scoreboard players set #24000 ssns.value 24000
scoreboard players set #50 ssns.value 50
scoreboard players set #30 ssns.value 30
scoreboard players set #20 ssns.value 20
scoreboard players set #100 ssns.value 100
scoreboard players set #-1 ssns.value -1
scoreboard players set #5 ssns.value 5
scoreboard players set #2 ssns.value 2
scoreboard players set #6000 ssns.value 6000
scoreboard players set #10000 ssns.value 10000

execute if score #once value matches 1 unless score #once ssns.value matches 1 run function seasons:convert_objectives
execute unless score #once ssns.value matches 1 run function seasons:install_once
scoreboard players set #once ssns.value 1

execute as @a if score @s temperature matches -2147483647.. run scoreboard players operation @s ssns.temperature = @s ssns.temperature
execute as @a if score @s ssns.wetness matches -2147483647.. run scoreboard players operation @s ssns.wetness = @s wetness
execute as @a if score @s temperature matches -2147483647.. run scoreboard players reset @s temperature
execute as @a if score @s ssns.wetness matches -2147483647.. run scoreboard players operation @s wetness

function seasons:options/calc_durations

advancement revoke @a only seasons:craft_calendar
recipe take @a seasons:calendar

execute unless score #temperature ssns.value matches 0..1 run scoreboard players set #temperature ssns.value 1
execute unless score #temperatureover ssns.value matches 0..1 run scoreboard players set #temperatureover ssns.value 1
execute unless score #temperaturenether ssns.value matches 0..1 run scoreboard players set #temperaturenether ssns.value 1
execute unless score #temperatureend ssns.value matches 0..1 run scoreboard players set #temperatureend ssns.value 1
execute unless score #weather ssns.value matches 0..1 run scoreboard players set #weather ssns.value 1
execute unless score #wetness ssns.value matches 0..1 run scoreboard players set #wetness ssns.value 1
execute unless score #skeleToStrays ssns.value matches 0..1 run scoreboard players set #skeleToStrays ssns.value 1
execute unless score #zombToHusks ssns.value matches 0..1 run scoreboard players set #zombToHusks ssns.value 1

execute unless score #sandstorm ssns.value matches 0..1 run scoreboard players set #sandstorm ssns.value 1
execute unless score #endIncurOn ssns.value matches 0..1 run scoreboard players set #endIncurOn ssns.value 1
execute unless score #bloodMoonOn ssns.value matches 0..1 run scoreboard players set #bloodMoonOn ssns.value 1
execute unless score #springFestival ssns.value matches 0..1 run scoreboard players set #springFestival ssns.value 1
execute unless score #solstice ssns.value matches 0..1 run scoreboard players set #solstice ssns.value 1
execute unless score #snowfreeze ssns.value matches 0..1 run scoreboard players set #snowfreeze ssns.value 1
execute unless score #flowerchange ssns.value matches 0..1 run scoreboard players set #flowerchange ssns.value 1
execute unless score #smoldering ssns.value matches 0..1 run scoreboard players set #smoldering ssns.value 1

execute unless score #snow ssns.value matches 0..1 run scoreboard players set #snow ssns.value 1
execute unless score #blizzard ssns.value matches 0..1 run scoreboard players set #blizzard ssns.value 1
execute unless score #smoke ssns.value matches 0..1 run scoreboard players set #smoke ssns.value 1
execute unless score #leaves ssns.value matches 0..1 run scoreboard players set #leaves ssns.value 1
execute unless score #sandstormpart ssns.value matches 0..1 run scoreboard players set #sandstormpart ssns.value 1

execute unless score #deathhusk ssns.value matches 0..1 run scoreboard players set #deathhusk ssns.value 1
execute unless score #deathstray ssns.value matches 0..1 run scoreboard players set #deathstray ssns.value 1

scoreboard players set playersCount ssns.marker 0
execute as @a run scoreboard players add playersCount ssns.marker 1
scoreboard players set @a ssns.marker 0
scoreboard players set i ssns.marker 0
kill @e[name=weatherMarker,type=area_effect_cloud]

tellraw @a ["",{"text":"[Seasons Datapack] ","color":"white"},{"text":"Initialisation completed","bold":"true","color":"green"}]
